//------------------------------------
// Archivo de encabezamiento AlladronAnimado.h
//-------------------------------------
#pragma once

//-------------------------
// Archivos de inclusin
//-------------------------
#include <windows.h>
#include "Recursos.h"
#include "NucleoMotor.h"
#include "cBMP.h"
#include "cSprite.h"

//------------------------
// Variable globales
//------------------------
// objeto juego
NucleoMotor*    g_pJuego;

// Constantes
const int       g_iQArboles = 12;
const int       g_iQDestinos = 13;
const int       g_iQShots = 10;

// Bitmaps del juego
cBMP *          g_pLadron[3];
cBMP *          g_pTomate;
cBMP *          g_pArbol;
cBMP *          g_pAuto;
cBMP *          g_pAutoRobado;
cBMP *          g_pMirilla;
cBMP *          g_pFondoJuego;

// Bitmaps de impactos
cBMP *          g_pImpactoTomate;


// Sprites (mapas de bits con animacin)
cSprite *       g_pcsLadron;
cSprite *       g_pcsArbol[g_iQArboles];
cSprite *       g_pcsTomate[g_iQShots];
cSprite *       g_pcsAuto;
cSprite *       g_pcsMirilla;


// Contadores del juego
int             g_iLadronesDetenidos;
int             g_iAutosRobados;
int             g_iTomatesArrojados;
int             g_iDestinos;
int             g_iPosActual;


// zonas en donde se puede ocultar
// el ladrn
RECT            g_rDestinos[g_iQDestinos];

// Variable auxiliar para contar bucles
// til para la depuracin y para
// ciertas lgicas de animacin
int             g_iContBucle;

// Indicador de fin de juego
BOOL            g_bFinJuego;


// Para bfer auxiliar para
// eliminar el parpadeo
HDC             g_hBuferAuxDC;
HBITMAP         g_hBuferAuxBitmap;

// Constantes para identificar los objetos
typedef         INT         TIPO_OBJ;
const           TIPO_OBJ    LADRON = 100,
                            TOMATE = 200,
                            AUTO = 300,
                            MIRILLA = 400,
                            ARBOL = 500;


