//------------------------------------
// Archivo de encabezamiento Blitzkrieg4.h
//-------------------------------------
#pragma once

//-------------------------
// Archivos de inclusin
//-------------------------
#include <windows.h>
#include "Recursos.h"
#include "NucleoMotor.h"
#include "cBMP.h"
#include "cSprite.h"

//------------------------
// Variable globales
//------------------------
// objeto juego
NucleoMotor*    g_pJuego;

// Cantidad de aviones y misiles
const int       g_iQShots = 40;

// Bitmaps del juego
cBMP *          g_pAvion[2];
cBMP *          g_pBomba;
cBMP *          g_pMisil;
cBMP *          g_pCanon;
cBMP *          g_pFondoJuego;
cBMP *          g_pFinJuego;
cBMP *          g_pFuegoAnimado;
cBMP *          g_pAvionAnimado[2];
cBMP *          g_pPantallaInicial;
cBMP *          g_pParacaidista;
cBMP *          g_pParacaidistaAnimado;



// Bitmaps de impactos
cBMP *          g_pImpactoMisil;
cBMP *          g_pCanonEnLlamas;
cBMP *          g_pObjetivoCiudad;

// Sprites (mapas de bits con animacin)
cSprite *       g_pcsParacaidista[g_iQShots];
cSprite *       g_pcsMisil[g_iQShots];
cSprite *       g_pcsObjetivoCiudad[60];
cSprite *       g_pcsCanon;

// ndices para las matrices de sprites
int             g_iAtaques;
int             g_iParacaidistas;
int             g_iMisil;

// Contadores del juego
int             g_iBombasInterceptadas;
int             g_iParacaidistasEliminados;
int             g_iBombasExplotadas;
int             g_iMisilesFallados;
int             g_iAvionesAbatidos;
int             g_iDireccionMisil;
int             g_iMotivoFin;
int             g_iScore;

// Variable auxiliar para contar bucles
// til para la depuracin y para
// ciertas lgicas de animacin
int             g_iContBucle;

// Indicador de fin de juego
BOOL            g_bFinJuego;
BOOL            g_bCanonDestruido;
MODO            g_bModo;

//tiempo de espera para entrar en modo demo
const int       g_iEsperaModoDemo = 120;
int             g_iCiclosEspera;




// Para bfer auxiliar para
// eliminar el parpadeo
HDC             g_hBuferAuxDC;
HBITMAP         g_hBuferAuxBitmap;

// Constantes para identificar los objetos
typedef         INT         TIPO_OBJ;
const           TIPO_OBJ    AVION   = 100,
                            BOMBA   = 200,
                            MISIL   = 300,
                            CANON   = 400,
                            PAISAJE = 500,
                            CIUDAD  = 600,
                            PILOTO  = 700;

// Funcin auxiliar de Blitzkrieg.cpp
void    Misil(int iDisparo);
void    LanzarBombas();
void    AgregarAvion();
int     RadarDetectaMisil(POINT ptPos);
void    AgregarParacaidista(RECT rcPos);
// Control del modo del juego
void    VerificarModo();

