//-----------------------------------------------------------------
// Archivo de cdigo C++ - Blitzkrieg5.cpp
//-----------------------------------------------------------------
//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "Blitzkrieg5.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------

// Inicializacin

BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Blitzkrieg5"), TEXT("Blitzkrieg5"),
    IDI_BLITZKRIEG4, IDI_BLITZKRIEG4_SM,
    780, 580, 20);  // frecuencia 20 fps equivale a 1 ciclo cada
                    // 50 milisegundos

  // si no se pudo crear el objeto juego
  // no se inicia
  if (g_pJuego == NULL)
    return false;

  // Se inicializa el joystick
  // si no hubiera joystick la funcin
  // devuelve false
  g_pJuego->InicializarJoystick();

  return true;
}

// Comienzo del juego

void FJ_ComenzarJuego(HWND hWindow)
{

  // Obtiene un handle al contexto de dispositivo
  HDC hDC = GetDC(hWindow);

  // Crea una serie de mapa de bits
  // Los mapas de bits son de profundidad 24 bits

  // Fondo del juego
  g_pFondoJuego = new cBMP(hDC, IDB_FondoJuego,
            g_pJuego->ObtenerInstancia());

  // Pantalla inicial
  g_pPantallaInicial= new cBMP(hDC, IDB_PantallaInicial,
            g_pJuego->ObtenerInstancia());

  // Fin del juego
  g_pFinJuego= new cBMP(hDC, IDB_FinJuego,
            g_pJuego->ObtenerInstancia());

  // Objetos principales

  // Los dos tipos de aviones
  // uno para el que va hacia la derecha
  // y el otro el que va hacia la izquierda
  g_pAvion[0] = new cBMP(hDC, IDB_Avion0, g_pJuego->ObtenerInstancia());
  g_pAvion[1] = new cBMP(hDC, IDB_Avion1, g_pJuego->ObtenerInstancia());

  // Bitmap del lanzador de misiles tierra - aire
  g_pCanon = new cBMP(hDC, IDB_Canon, g_pJuego->ObtenerInstancia());

   // Bitmap de la bomba que arroja cada avin
  g_pBomba = new cBMP(hDC, IDB_Bomba, g_pJuego->ObtenerInstancia());

  // Bitmap de los misiles tierra - aire
  g_pMisil = new cBMP(hDC, IDB_Misil, g_pJuego->ObtenerInstancia());

  // Bitmap que representa los objetivos de la ciudad
  g_pObjetivoCiudad = new cBMP(hDC, IDB_ObjetivoCiudad,
            g_pJuego->ObtenerInstancia());

  // Impactos (colisiones)


  // el impacto de un misil con un avin o una bomba es un bitmap nico
  g_pImpactoMisil = new cBMP(hDC, IDB_ImpactoMisil,
            g_pJuego->ObtenerInstancia());

  // Si hay un impacto al can se muestra otro
  // mapa de bits
  g_pCanonEnLlamas = new cBMP(hDC, IDB_CanonEnLlamas,
            g_pJuego->ObtenerInstancia());

  // Bitmap que representa el fuego animado
  // que se genera al expolotar una bomba en la ciudad
  g_pFuegoAnimado = new cBMP(hDC, IDB_FuegoAnimado,
            g_pJuego->ObtenerInstancia());

   // Bitmap que representa el avin en llamas
  g_pAvionAnimado[0] = new cBMP(hDC, IDB_Avion0Animado,
            g_pJuego->ObtenerInstancia());

   // Bitmap que representa el avin en llamas
  g_pAvionAnimado[1] = new cBMP(hDC, IDB_Avion1Animado,
            g_pJuego->ObtenerInstancia());

  // Bitmap del paracaidista cuando salta del avin
  g_pParacaidista = new cBMP(hDC, IDB_Paracaidista,
            g_pJuego->ObtenerInstancia());
  // bitmap del paracaidista en tierra (animado)
  g_pParacaidistaAnimado = new cBMP(hDC, IDB_ParacaidistaAnimado,
            g_pJuego->ObtenerInstancia());

  // Gestin del modo
  // se inicia con la pantalla
  // de presentacin (Splash)
  // hay 4 modos:
  // MODOINICIO: pantalla de presentacin
  // MODODEMO: juego simulado
  // MODOJUEGO: juego real
  // MODOFIN: al finalizar cada juego y antes de
  // volver al modo demo

  g_bModo = MODOINICIO;

  // el modo inicio es transitorio
  // despus pasar a modo demo
  g_iCiclosEspera = 0;

  // Leer los records del juego
  // archivo records
  LeerRecords();

  // Inicializar los contadores del juego
  FJ_NuevoJuego();

  // Bfer auxiliar de repintado
  // Crea un contexto de dispositivo y un
  // mapa de bits adicional
  g_hBuferAuxDC = CreateCompatibleDC(hDC);
  g_hBuferAuxBitmap = CreateCompatibleBitmap(hDC,
      g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
  SelectObject(g_hBuferAuxDC , g_hBuferAuxBitmap);

 }

 // Inicializacin antes de cada juego

void FJ_NuevoJuego()
{
  // Funcin de limpieza de las variables
  // para reiniciar un nuevo
  g_pJuego->LimpiarVector();    // Se limpian los sprites del vector
  g_iAtaques = 0;               // Aviones lanzados
  g_iParacaidistas = 0;         // Paracaidistas lanzados
  g_iParacaidistasEliminados = 0; // Paracaidistas eliminados
  g_iMisil = 0;                 // Misiles lanzados
  g_iBombasInterceptadas = 0;   // Bombas interceptadas
  g_iBombasExplotadas = 0;      // Bombas explotadas
  g_iMisilesFallados = 0;       // Misiles fallados
  g_iAvionesAbatidos = 0;       // Aviones abatidos
  g_iDireccionMisil = 4;        // Misil seleccionado

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

  g_bFinJuego = false;          // Indicador de fin de juego
  g_iScore = 0;                 // Score
  g_bCanonDestruido = false;    // Indicador de can destruido

  // Definicin de las reas de accin de  los
  // distintos tipos de sprites

  // el rea de movimiento = toda la pantalla
  RECT rcAreaJuego = {0, 0,
        g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura()};

  // El hot spot de cada objetivo de la ciudad coincide con
  // el tamao de la cuadrcula del mapa de bit del
  // objetivo
  RECT rcAreaObjetivo = {0, 0,
        g_pObjetivoCiudad->ObtenerAncho(),
        g_pObjetivoCiudad->ObtenerAltura()};

  // OBJETIVOS EN LA CIUDAD
  // Crea los sprites que definen los objetivos en
  // la ciudad
  // la posicin de cada sprite es variable, para formar una
  // cuadrcula con todos los objetivos de la ciudad
  POINT ptPos = {0,0};
  // la ciudad es un objetivo esttico
  POINT ptVel = {0,0};

  for (int i = 0; i < 20; i++)
  {
      for (int j = 0; j < 3; j++)
      {
        // define cada cuadrcula una tras otra
        // con velocidad (0,0) y orden Z = 1
        ptPos.x = i * g_pObjetivoCiudad->ObtenerAncho();
        ptPos.y = j * g_pObjetivoCiudad->ObtenerAltura() + 365;
        g_pcsObjetivoCiudad[20 * j + i] = new
                cSprite(g_pObjetivoCiudad,
                ptPos, rcAreaObjetivo, ptVel, 1,
                rcAreaJuego, AFL_DETENER);
        // A cada sprite le asignamos el identificador CIUDAD
        g_pcsObjetivoCiudad[20 * j + i]->AsignarID(CIUDAD);
        g_pJuego->AgregarSprite(g_pcsObjetivoCiudad[20 * j + i]);
      }
  }

  // CAN
  // Creamos el sprite del lanza misiles (can)
  RECT rcHotSpot = {30,30,120,60};

  g_pcsCanon = new cSprite(g_pCanon, rcAreaJuego, AFL_DETENER);
  g_pcsCanon->AsignarID(CANON);
  g_pcsCanon->AsignarPosicion((g_pJuego->ObtenerAncho()-
                        g_pCanon->ObtenerAncho())/2,
                        g_pJuego->ObtenerAltura()-
                        g_pCanon->ObtenerAltura());

  // El can tiene un punto sensible muy pequeo
  // si recibe un impacto se termina el juego
  g_pcsCanon->AsignarHotSpot(rcHotSpot);
  g_pcsCanon->AsignarcBmpAlternativo(g_pCanonEnLlamas);
  g_pJuego->AgregarSprite(g_pcsCanon);

  // MISILES
  for (int i = 0; i < g_iQShots; i++)
  {
    g_pcsMisil[i] = new cSprite(g_pMisil,
                            rcAreaJuego,
                            AFL_DESAPARECER);
    // No se define un hot spot dado que
    // el bitmap es muy ajustado y el tamao
    // del bitmap coincide con el hot spot
    g_pcsMisil[i]->AsignarOrdenZ(2);
    g_pcsMisil[i]->AsignarPosicion(g_pJuego->ObtenerAncho()/2,
            g_pJuego->ObtenerAltura()-50);

    // Los misiles nacen invisibles
    // los haremos visibles al lanzarlos (al
    // darles velocidad)
    g_pcsMisil[i]->AsignarVisibilidad(false);
    g_pcsMisil[i]->AsignarcBmpImpacto(g_pImpactoMisil);
    // los proyectiles tienen identificadores MISIL = 300
    g_pcsMisil[i]->AsignarID(MISIL);
    g_pJuego->AgregarSprite(g_pcsMisil[i]);
  }

  // Reinicia la reproduccin de la msica de fondo
  g_pJuego->MIDI(PLAYMIDI, TEXT("fondo.mid"));
}

// Funciones de mouse

void FJ_LButtonDown(LPARAM lParam)
{
   // Botn izquierdo reinicia el juego
   if (g_bFinJuego)
     FJ_NuevoJuego();
}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
}

// Funciones de teclado

void FJ_CheckTeclado()
{
    if (GetAsyncKeyState(VK_F3) < 0)
    {
        g_bModo = MODOJUEGO;
        FJ_NuevoJuego();
    }
}
void FJ_TeclaCaracter(WPARAM wParam)
{
    // salen a distintas direcciones
    // esto se resuelve con diferentes velocidades
    // sobre el eje x y el eje y
    if (g_iMisil == g_iQShots)
        return;

    // Conversin de la tecla a nmero
    int iTecla = int(wParam) - 48;

    // Se usa una funcin auxiliar comn para teclado y joystick
    Misil(iTecla);
}

// Comprobar el joystick

void FJ_CheckJoystick(WORD wJoyEstado)
{
    // El joystick permite una definicin de 7 direcciones de
    // lanzamiento de misiles
    // Botn 3: Termina el juego y reinicia otro
    if (wJoyEstado & JBOT3)
    {
        FJ_NuevoJuego();
        return;
    }
    if (g_iMisil == g_iQShots)
        return;


    // Los botones IZQ, DER y ARRIBA
    // del joystick sirven para
    // elegir la direccin del misil
    if (wJoyEstado & JIZQ)
        g_iDireccionMisil--;
    if (wJoyEstado & JDER)
        g_iDireccionMisil++;
    // 4 es el misil vertical
    if (wJoyEstado & JARRIBA)
        g_iDireccionMisil = 4;

    // El rango de direcciones es de 1 a 7
    // 1, 2 y 3 son direcciones hacia la izquierda
    // 4 es un misil vertical
    // 5, 6, y 7 son direcciones hacia la derecha
    g_iDireccionMisil = max(g_iDireccionMisil,1);

    g_iDireccionMisil = min(g_iDireccionMisil,7);

    // El botn 1 dispara el misil
    if (wJoyEstado & JBOT1)
        Misil(g_iDireccionMisil);
}

// Ciclo del juego

void FJ_CicloJuego()
{

    // Se acaba el juego si...
    if (!g_bFinJuego)
    {
        // 1. se acaban los aviones y sus bombas
        g_iMotivoFin = 0;
        if  (g_iQShots <= g_iBombasExplotadas +
                              g_iBombasInterceptadas)
                g_iMotivoFin = 1;
        // 2. si se acaban los misiles
        // (no se usa el contador g_iMisil porque
        // los misiles tardan en llegar a destino)
        if (g_iQShots <= g_iAvionesAbatidos +
                             g_iBombasInterceptadas +
                             g_iMisilesFallados +
                             g_iParacaidistasEliminados)
                g_iMotivoFin = 2;
        // 3. se acaba por destruccin del can
        if (g_bCanonDestruido)
                g_iMotivoFin = 3;

        // calcula el score actual
        g_iScore = g_iAvionesAbatidos *3 +
            g_iBombasInterceptadas * 5 + g_iParacaidistasEliminados;

        if (g_iMotivoFin != 0)
       {
             // se penaliza la destruccin del can
            if (g_iMotivoFin == 3)
                g_iScore *=.75;
            // actualizar el score (si es record)
            ActualizarRecords(g_iScore);
            g_bFinJuego = true;
        }
    }

    // hay actividad en modo demo y modo juego
     if (g_bModo & ( MODOJUEGO | MODODEMO) )
    {
        // en modo demo
        // dispara un misil cada 20 ciclos
        if (g_bModo == MODODEMO && g_iContBucle % 20 == 0)
        {
            int iTecla = rand() % 8 + 48;
            FJ_TeclaCaracter(iTecla);
        }

        // Aparecen bombarderos, de a uno y cada 40 ciclos
        if ((g_iContBucle % 40 == 0) && (g_iAtaques < g_iQShots))
            AgregarAvion();

        // se lanzan bombas desde los aviones cada x ciclos
        if ((g_iContBucle % 30 == 0) && (g_iAtaques < g_iQShots))
            LanzarBombas();

        // Actualiza las posiciones de los sprites
        g_pJuego->ActualizarSprites();
    }
    ++g_iContBucle;

    // Pintar en el contexto de dispositivo
    // auxiliar para eliminar
    // la sensacin de parpadeo
    FJ_PintarJuego(g_hBuferAuxDC);

    // Pintura real de la pantalla en una nica operacin
    HWND hVentana = g_pJuego->ObtenerVentana();
    HDC hDC = GetDC(hVentana);

    // se utilizan coordenadas 0, 0
    // porque se realiza copia completa
    // de un rea a otra
    BitBlt(hDC,
            0, 0, g_pJuego->ObtenerAncho(),
            g_pJuego->ObtenerAltura(),
            g_hBuferAuxDC, 0, 0,
        SRCCOPY);

    ReleaseDC(hVentana, hDC);

    // Se depuran los sprites marcados para eliminar
    g_pJuego->DepurarSprites();

}

// Funcin de dibujo de la pantalla

void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};

    // El fondo del juego se pinta primero
    g_pFondoJuego->Dibujar(hDC, ptOrigen);

    // comprobamos en qu modo de interfaz estamos
    VerificarModo();

    // Si est en modo inicio  o demo
    // muestra la pantalla de presentacin
    // y los records actuales
    if (g_bModo & (MODOINICIO | MODODEMO))
    {
        g_pPantallaInicial->Dibujar(hDC,
            (g_pJuego->ObtenerAncho() -
             g_pPantallaInicial->ObtenerAncho()) / 2,
            (g_pJuego->ObtenerAltura() -
             g_pPantallaInicial->ObtenerAltura()) / 2,
            true);
         // se informan los tres mejores resultados
         int iPy =450;
         for (int i = 0; i < 3; i++)
         {
             char szTexto[50];
             wsprintf(szTexto, "Record %d: %d",  i+1, g_iRecords[i]);
             TextOut(hDC, 620, iPy, szTexto, strlen(szTexto));
             iPy += 20;
         }

    }
    // en modo demo o en modo juego o en modo fin
    // actualizamos los sprites de
    // la interfaz
    if (g_bModo != MODOINICIO)
    {
        // Misiles restantes y disponibles
        // se dibujan en la parte superior
        // de la pantalla
        for( int i = 0; i < (g_iQShots - g_iMisil); i++)
                g_pMisil->Dibujar(hDC,150 + i * 12,0, true);

        // Ahora dibuja los sprites desde el vector
        // que pertenece al NucleoMotor
        g_pJuego->DibujarSprites(hDC);

        // Coloca el puntaje vigente
        char szTexto[100];
        wsprintf(szTexto, "Puntaje = %d", g_iScore);
        TextOut(hDC, 0, 0, szTexto, strlen(szTexto));

         // Si finaliz el juego
         // muestra el motivo del final
         // del juego y el mapa de bits
         // de final del juego
        if (g_bFinJuego)
        {
            POINT ptDibujo;
            // Coloca el mapa de bits de fin de juego
            ptDibujo.x = (g_pJuego->ObtenerAncho() -
                g_pFinJuego->ObtenerAncho()) / 2;
            ptDibujo.y = (g_pJuego->ObtenerAltura()-
                g_pFinJuego->ObtenerAltura()) / 2;
            g_pFinJuego->Dibujar(hDC, ptDibujo, TRUE, RGB(255, 0, 255));


            switch(g_iMotivoFin)
            {
                case 1:
                    wsprintf(szTexto, "Fin del juego: Se acabaron los ataques. Su puntaje es %d. (F3= Nuevo juego)",
                        g_iScore);
                break;
                case 2:
                    wsprintf(szTexto, "Fin del juego: Se acabaron los misiles de defensa. Su puntaje es %d. (F3= Nuevo juego)",
                        g_iScore);
                break;
                case 3:
                    wsprintf(szTexto, "Fin del juego: Se destruy el can de defensa. Su puntaje es %d. (F3= Nuevo juego)",
                        g_iScore);
                break;
            }
            TextOut(hDC, 0, 100, szTexto, strlen(szTexto));


            // Pausar la msica de fondo
            g_pJuego->MIDI(PAUSARMIDI);
         }
    }

}

// Activacin y reactivacin del juego

void FJ_ReactivarJuego(HWND hWindow)
{
    // Capturar el joystick
    g_pJuego->CapturarJoystick();

    // reactiva la msica de fondo
    // con la msica que se estaba
    // reproduciendo en el momento
    // de la pausa
    g_pJuego->MIDI(PLAYMIDI,NULL,false);
}
void FJ_DetenerJuego(HWND hWindow)
{
    // Liberar el joystick
     g_pJuego->LiberarJoystick();

    // Suspende la msica de fondo
    g_pJuego->MIDI(PAUSARMIDI);
}

// Finalizacin del programa

void FJ_FinalizarJuego()
{
  // Registra los records del juego
  // en el archivo records
  RegistrarRecords();

  // Elimina los elementos del bfer auxiliar
  DeleteObject(g_hBuferAuxBitmap);
  DeleteObject(g_hBuferAuxDC);

  // Elimina objetos bmp
  delete g_pAvion[0];
  delete g_pAvion[1];
  delete g_pBomba;
  delete g_pCanon;
  delete g_pMisil;

  // Bitmap de impacto
  delete g_pFuegoAnimado;
  delete g_pAvionAnimado[0];
  delete g_pAvionAnimado[1];
  delete g_pImpactoMisil;
  delete g_pCanonEnLlamas;
  delete g_pObjetivoCiudad;
  delete g_pFinJuego;


  // Limpieza del vector de sprites
  g_pJuego->LimpiarVector();

  // elimina el mapa de bits de fondo
  delete g_pFondoJuego;
  // elimina la pantalla inicial
  delete g_pPantallaInicial;

  // Elimina el objeto
  delete g_pJuego;

  // Cierra el dispositivo
  g_pJuego->MIDI(CERRARMIDI);
}

// Control de las colisiones
// entre objetos cSprite

APC_ACCION FJ_NotificarColision(TC_COLISION tcColision,
        cSprite* pSprite, cSprite* pSpriteImpactado)
{


     switch (tcColision)
     {
        case TC_SPRITE:
            if (pSprite->ObtenerDensidad() == 0 ||
                    pSpriteImpactado->ObtenerDensidad() == 0)
                return APC_NOACCION;

            if (pSprite->ObtenerID() == MISIL ||
                    pSpriteImpactado->ObtenerID() == MISIL)
            {
                // si se impacta un avin se sumariza
                cSprite * pSpriteTemp;
                // si se impacta un avin se sumariza
                // (el avion puede impactar o ser impactado)
                if (pSprite->ObtenerID() == AVION ||
                        pSpriteImpactado->ObtenerID() == AVION)
                {
                    if (pSprite->ObtenerID() == AVION)
                    {
                        pSpriteTemp = pSprite;
                        pSpriteImpactado->AsignarVisibilidad(false);
                    }
                    else
                    {
                        pSpriteTemp = pSpriteImpactado;
                        pSprite->AsignarVisibilidad(false);
                    }
                    g_iAvionesAbatidos++;
                    PlaySound((LPCSTR) IDW_MISIL,
                            g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
                       // si slo se tiene 1 misil se pone
                       // la msica de suspenso
                    if (g_iAtaques == g_iQShots - 1)
                        g_pJuego->MIDI(PLAYMIDI,TEXT("unavida.mid"));
                    // pelcula:
                    // Se empieza la reproduccin de los
                    // fotogramas que componen la
                    // imagen alternativa
                    pSpriteTemp->CambiarImagen();
                    pSpriteTemp->AsignarCantidadImagenes(6);
                    pSpriteTemp->AsignarVelocidad(0, 3);
                    pSpriteTemp->AnimarUnaVez(true);
                    pSpriteTemp->AsignarDemoraAnimacion(2);
                    pSpriteTemp->AsignarDensidad(0);
                    // Aleatoriamente, el piloto se salva
                    // lanzndose en paracadas
                    if (rand() % 2 == 0)
                       AgregarParacaidista(pSpriteTemp->ObtenerPosicion());
                    return APC_NOACCION;
                }
                // Misil intercepta una bomba
                if (pSprite->ObtenerID() == BOMBA ||
                        pSpriteImpactado->ObtenerID() == BOMBA)
                {
                    g_iBombasInterceptadas++;
                    return APC_DESTRUIR2;
                }
                // Misil intercepta un paracaidista
                if (pSprite->ObtenerID() == PILOTO ||
                        pSpriteImpactado->ObtenerID() == PILOTO)
                {
                    g_iParacaidistasEliminados++;
                    return APC_DESTRUIR2;
                }
            }
            else
            {
                if (pSpriteImpactado->ObtenerID() == CANON)
                {
                    // Pone la imagen de las llamas
                    pSpriteImpactado->CambiarImagen();
                    // a partir de hora ya ningn objeto
                    // podr impactar con los restos del can
                    // pero el juego terminar
                    pSpriteImpactado->AsignarDensidad(0);
                    PlaySound((LPCSTR) IDW_KO,
                            g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
                    // Can destrudo
                    g_bCanonDestruido = true;
                }
            }
            break;
        case TC_LIMITES:
            // La bomba explota en la ciudad
            if (pSprite->ObtenerID() == BOMBA)
            {
                PlaySound((LPCSTR) IDW_BOMBA,
                    g_pJuego->ObtenerInstancia(),
                    SND_ASYNC | SND_RESOURCE);
                g_iBombasExplotadas++;

                // pelcula:
                // Se empieza la reproduccin de los
                // fotogramas que componen la
                // imagen del fuego animado
                // el fuego tiene densidad 0
                // (no puede colisionar con nada)
                pSprite->AsignarDensidad(0);
                pSprite->CambiarImagen(g_pFuegoAnimado);
                pSprite->AnimarAunQuieto(true);
                pSprite->AsignarCantidadImagenes(5);
                return APC_NOACCION;
            }
            // el misil se pierde por la parte
            // superior de la pantalla
            if (pSprite->ObtenerID() == MISIL)
            {
                g_iMisilesFallados++;
                return APC_DESTRUIR;
            }
            // el avin sale por uno de los laterales
            // de la pantalla
            if (pSprite->ObtenerID() == AVION)
                return APC_DESTRUIR;

            // al llegar a tierra
            // el paracaidista camina hacia la
            // batera antiarea (can)
            // para destruirla
            if (pSprite->ObtenerID() == PILOTO)
            {
                RECT rcPos = pSprite->ObtenerPosicion();
                RECT rcArea;
                if (rcPos.left < g_pJuego->ObtenerAncho() / 2)
                    pSprite->AsignarVelocidad(3, 0);
                 else
                    pSprite->AsignarVelocidad(-3, 0);
                SetRect(&rcArea, 0,0,
                        g_pJuego->ObtenerAncho(),
                        g_pJuego->ObtenerAltura()+
                        g_pParacaidistaAnimado->ObtenerAltura());
                pSprite->CambiarImagen(g_pParacaidistaAnimado);
                pSprite->AsignarCantidadImagenes(3);
                pSprite->AnimarAunQuieto(false);
                pSprite->AsignarAreaAccion(rcArea);
                SetRect(&rcArea,0,0,25,25);
                pSprite->AsignarHotSpot(rcArea);
                rcPos.top =555;
                pSprite->AsignarPosicion(rcPos);
                return APC_NOACCION;
            }
            break;
        // otras opciones
        // reservamos para uso futuro
    }
    return APC_NOACCION;
}

//-------------------------------------------------------
// Funciones propias de cada juego
//-------------------------------------------------------

// Control de los misiles del ujugador

void Misil(int iDisparo)
{
    int i;
    if (iDisparo > 0 && iDisparo < 8)
    {
        g_iMisil++;
        i = g_iMisil - 1;
        g_pcsMisil[i]->AsignarVisibilidad(true);
        PlaySound((LPCSTR) IDW_DISPARO, g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
    }

    switch (iDisparo)
    {
        case 1:
            g_pcsMisil[i]->AsignarVelocidad(-11,-3);
            break;
        case 2:
            g_pcsMisil[i]->AsignarVelocidad(-8, -8);
            break;
        case 3:
            g_pcsMisil[i]->AsignarVelocidad(-6,-10);
            break;
        case 4:
            g_pcsMisil[i]->AsignarVelocidad(0, -12);
            break;
        case 5:
            g_pcsMisil[i]->AsignarVelocidad(6,-10);
            break;
        case 6:
            g_pcsMisil[i]->AsignarVelocidad(8,-8);
            break;
        case 7:
            g_pcsMisil[i]->AsignarVelocidad(11, -3);
        break;
    }
}

// Agregar aviones al juego

void AgregarAvion()
{
    // Suma los aviones que van apareciendo
    g_iAtaques++;

    // Se define un rectngulo para el lmite
    // del movimiento de los aviones: media pantalla (superior)
    // la lnea del horizonte est en y = 365
    RECT rcAreaAvion = {0, 0,
        g_pJuego->ObtenerAncho(), 300};

    // Definimos un hot spot menor que el
    // rectgulo del mapa de bits del avin
    // el mapa de bits es de 124 x 32
    // por lo tanto, el rea sensible
    // es bastante menor 80 x 25
    RECT rcHotSpot = {20, 5, 100, 30};

    // Se calcula si el avin aparece por la izquierda o por la
    // derecha. Tambin sirve para definir el signo de la velocidad
    // y la imagen del avin
    int iIzqDer = rand() % 2;

    POINT ptPos = {0, 0};
    ptPos.y = rand() % 300;

    POINT ptVel = {0, 0};
    ptVel.x = rand() % 20 + 5;

    // si sale desde la derecha
    // la velocidad es negativa
    // y la posicin x es mxima
    if (iIzqDer == 1)
    {
        ptVel.x = -ptVel.x;
        ptPos.x = g_pJuego->ObtenerAncho();
    }

    // Se crea el sprite con orden Z = 2
    // el avin desaparece al llegar al lmite
    cSprite * pcSTemp = new cSprite(g_pAvion[iIzqDer],
                            ptPos, rcHotSpot, ptVel, 2,
                            rcAreaAvion, AFL_DESAPARECER);

    // los aviones tienen identificadores 100
    pcSTemp->AsignarID(AVION);

    // Se asigna una imagen para utilizarla cuando
    // se produzca una colisin con un misil
    pcSTemp->AsignarcBmpAlternativo(g_pAvionAnimado[iIzqDer]);

    // Se grega el avin al vector de sprites
    g_pJuego->AgregarSprite(pcSTemp);
}

// Lanzamiento de las bombas
// desde los aviones

void LanzarBombas()
{

    // Obtenemos la lista de los aviones activos
    // para asignarle una bomba (aleatoriamente)
    vector<cSprite*> vcSprites =  g_pJuego->ObtenerSprites(AVION);

      // Crea un iterador para navegar por el vector
    vector<cSprite*>::iterator ivSprite = vcSprites.begin();

    // La funcin erase en el compilador Microsoft de Visual C++ 2008
    // suele corromper al iterador por lo que se modifica
    // ivSprite-- por un cdigo equivalente que funciona
    // en Code::Blocks y Microsoft
    //for (ivSprite = m_vcSprites.begin(); ivSprite != m_vcSprites.end(); ivSprite++)
    // el rea de movimiento de las bombas
  // la asignaremos de modo individual
    RECT rcAreaBomba = {0, 0, g_pJuego->ObtenerAncho(),
        g_pJuego->ObtenerAltura()};
    RECT rcHotSpot = {0, 0, g_pBomba->ObtenerAncho(),
        g_pBomba->ObtenerAltura()};
    while (ivSprite != vcSprites.end())
    {
        RECT rOrigen =  (*ivSprite)->ObtenerPosicion();
        POINT ptAvion;
        // Calculamos el punto medio del avin
        ptAvion.x =  rOrigen.left + (*ivSprite)->ObtenerAncho() /2;
        ptAvion.y = rOrigen.top + (*ivSprite)->ObtenerAltura() / 2;

        // si hay un misil a menos de 200 px
        // se modifica la velocidad para esquivarla
        if (RadarDetectaMisil(ptAvion) <= 200)
        {
            POINT ptVelAvion = (*ivSprite)->ObtenerVelocidad();
            (*ivSprite)->AsignarVelocidad(ptVelAvion.x * 3, -5);
        }

        // se lanzan bombas desde
        // los aviones que estn en pantalla (de modo aleatorio)
        int i = rand() % 2;
        if (i == 0)
        {
            // la bomba sale desde el avin
            // el destino es alguna parte de la ciudad
            // o el can
            int j = rand() % 61;
            RECT rDestino;
            if (j < 60)
                rDestino = g_pcsObjetivoCiudad[j]->ObtenerPosicion();
            else
                rDestino = g_pcsCanon->ObtenerPosicion();

            // Calculamos la velocidad de cada de la bomba
            // (de hecho es, velocidad y direccin)
            int iVelX = (rDestino.left - rOrigen.left) / 20;
            int iVelY = (rDestino.bottom - rOrigen.top) / 20;

            POINT ptPos = {rOrigen.left, rOrigen.top};
            POINT ptVel = {iVelX, iVelY};

            // La bomba se dirige a uno de los destinos disponibles
            UnionRect(&rcAreaBomba, &rOrigen, &rDestino);
            cSprite * pcSTemp = new cSprite(g_pBomba,
                                ptPos, rcHotSpot, ptVel, 1,
                                rcAreaBomba, AFL_DETENER);

            // las bombas tienen identificadores 200
            pcSTemp->AsignarID(BOMBA);
            g_pJuego->AgregarSprite(pcSTemp);
      }
     ivSprite++;
  }

}

// Radar de deteccin de misiles

int RadarDetectaMisil(POINT ptAvion)
{
    // Obtenemos la lista de misiles lanzados desde el can
    vector<cSprite*> vcSpritesMisil =  g_pJuego->ObtenerSprites(MISIL);

      // Crea un iterador para navegar por el vector
    vector<cSprite*>::iterator ivSpriteMisil = vcSpritesMisil.begin();

    // por defecto calculamos una distancia muy lejana
    int iDistancia = 1000;
    int iCont = 0;
    while (ivSpriteMisil != vcSpritesMisil.end())
    {
        RECT rcPos = (*ivSpriteMisil)->ObtenerPosicion();
        // calculamos la distancia entre misil y avin
        int y = rcPos.top - ptAvion.y;
        int x = rcPos.left - ptAvion.x;

        // si y es negativo, quiere decir que el misil ya pas
        // la lnea de vuelo y no hay que preocuparse
        if ( y > 0)
        {
            // la hipotenusa es la distancia
            int iDist = int(sqrt(x * x + y * y));
            // nos quedamos con la distancia mnima
            iDistancia = min(iDistancia, iDist);
        }
        ivSpriteMisil++;
        iCont++;
    }
    // distancia mnima entre el avin y los misiles lanzados
    return iDistancia;
}

// Agregar paracaidistas
void AgregarParacaidista(RECT rcPos)
{
    // Se define un rectngulo para
    // el rea de accin del paracaidista

    RECT rcAreaParacaidista;
    // la posicin se recibe como parmetro
    POINT ptPos;
    ptPos.y = rcPos.bottom;
    // pero el eje x, lo tenemos que manipular
    // para que el paracaidista no toque sus
    // lmites laterales
    if (rcPos.left < g_pJuego->ObtenerAncho()/2)
    {
        SetRect(&rcAreaParacaidista, 0, 0,
            g_pJuego->ObtenerAncho()/2, g_pJuego->ObtenerAltura());
        // la posicin se recibe como parmetro
        // pero desplazamos el paracaidista para que
        // no toque los lmites laterales
        ptPos.x = max(0,int(rcPos.left -
                g_pParacaidista->ObtenerAncho()));
    }
    else
    {
        SetRect(&rcAreaParacaidista, g_pJuego->ObtenerAncho()/2, 0,
            g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
        // la posicin se recibe como parmetro
        // pero desplazamos el paracaidista para que
        // no toque los lmites laterales
        ptPos.x = min(g_pJuego->ObtenerAncho()-
                g_pParacaidista->ObtenerAncho(),
                int(rcPos.right + g_pParacaidista->ObtenerAncho()));
    }

    // Definimos un hot spot menor que el
    // rectgulo del mapa de bits del paracaidista
    // (es un rea muy pequea, difcil de acertar)
    RECT rcHotSpot = {25, 25, 35, 60};

    // la velocidad es una cada lenta
    POINT ptVel = {0, 2};

    // Se crea el sprite con orden Z = 2
    // el paracaidista se detiene al llegar al lmite
    g_pcsParacaidista[g_iParacaidistas] = new cSprite(g_pParacaidista,
                            ptPos, rcHotSpot, ptVel, 2,
                            rcAreaParacaidista, AFL_DETENER);

    // los paracaidistas tienen identificadores PILOTO
    g_pcsParacaidista[g_iParacaidistas]->AsignarID(PILOTO);

    // Se agrega el paracaidista al vector de sprites
    g_pJuego->AgregarSprite(g_pcsParacaidista[g_iParacaidistas] );
    g_iParacaidistas++;
}

// Control de modos del juego

void VerificarModo()
{
    switch(g_bModo)
    {
         case MODOINICIO:
            // para que en modo demo se reinicie
            // automticamente
            g_iCiclosEspera++;
            if (g_iCiclosEspera >= g_iEsperaModoDemo)
            {
                g_bModo = MODODEMO;
                FJ_NuevoJuego();
                return;
            }
            break;

          case MODODEMO:
            // de MODODEMO slo se sale con F3
            // que comienza el juego
                 if (g_bFinJuego)
                 {
                    FJ_NuevoJuego();
                    return;
                 }
                 break;

           case MODOJUEGO:
            // al finalizar cada juego
            // se entra en modo MODOFIN, que
            // muestra la pantalla de fin de juego
            // durante un tiempo
                 if (g_bFinJuego)
                 {
                    g_bModo = MODOFIN;
                    g_iCiclosEspera = 0;
                    return;
                 }
                 break;

              case MODOFIN:
             // si entra en modo MODOFIN, se
             // muestra la pantalla de fin de juego
             // durante un tiempo y despus pasa
             // a MODODEMO
                 g_iCiclosEspera++;
                 if (g_iCiclosEspera >= g_iEsperaModoDemo)
                {
                     g_bModo = MODODEMO;
                     FJ_NuevoJuego();
                    return;
                }
                 break;

     }
 }

// Funciones para el mantenimiento de los
// mayores puntajes obtenidos


void LeerRecords()
{
    // Borra la matriz de records
    for (int i = 0; i < 3;i++)
        g_iRecords[i] = 0;

    // Abre el archivo de records
    HANDLE hArchivo = CreateFile(TEXT("Records"), GENERIC_READ, 0, NULL,
        OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL);
    if (hArchivo != INVALID_HANDLE_VALUE)
    {
        // Secuencia de lectura de records
        char cBuffer[5];
        DWORD dwBytes;
        for (int j = 0; j < 3; j++)
        {
            if (ReadFile(hArchivo, &cBuffer, 4, &dwBytes, NULL))
                g_iRecords[j] = atoi(cBuffer);
            else
            {
                // problema en la lectura del archivo
                CloseHandle(hArchivo);
                return;
            }
        }
        CloseHandle(hArchivo);
    }
    return;
}

void ActualizarRecords(int iScore)
{
    // Verifica si el resultado es un nuevo record
    // si no, no cambia la matriz
    // mantiene el orden ascendente
    for (int i = 0; i < 3; i++)
    {
        if (iScore > g_iRecords[i])
        {
            int temp = g_iRecords[i];
            g_iRecords[i] = iScore;
            iScore = temp;
        }
    }
}

void RegistrarRecords()
{

    // Abre el archivo de records
    HANDLE hArchivo = CreateFile(TEXT("Records"), GENERIC_WRITE, 0, NULL,
        CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hArchivo != INVALID_HANDLE_VALUE)
    {
        // Secuencia de lectura de records
        char cBuffer[5];
        DWORD dwBytes;
        for (int j = 0; j < 3; j++)
        {
            wsprintf(cBuffer, "%04d", g_iRecords[j]);
            if (!WriteFile(hArchivo, &cBuffer, 4, &dwBytes, NULL))
            {
                // problema en la escritura del archivo
                CloseHandle(hArchivo);
                return;
            }
        }
        CloseHandle(hArchivo);
        return;
    }
    return;
}




