//-----------------------------------------------------------------
// Archivo de cdigo C++ - MikePowell.cpp
//-----------------------------------------------------------------
//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "MikePowell.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("MikePowell"), TEXT("MikePowell"),
    IDI_MIKEPOWELL, IDI_MIKEPOWELL_SM,
    600, 400, 20);  // frecuencia 20 fps equivale a 1 ciclo cada
                    // 50 milisegundos

  // si no se pudo crear el objeto juego
  // no se inicia
  if (g_pJuego == NULL)
    return false;

  // Se inicializa el joystick
  // si no hubiera joystick la funcin
  // devuelve false
  g_pJuego->InicializarJoystick();

  return true;
}
void FJ_ComenzarJuego(HWND hWindow)
{

  // Obtiene un handle al contexto de dispositivo
  HDC hDC = GetDC(hWindow);

  // Crea una serie de mapa de bits
  // Los mapas de bits son de profundidad 24 bits

  // Fondo del juego
  // a travs de un objeto cFondo
  g_pFondoJuego = new cFondo(hDC, IDB_FondoJuego,
            g_pJuego->ObtenerInstancia());

  // primer plano del juego
  g_pFondoJuego2 = new cFondo(hDC, IDB_FondoJuego2,
            g_pJuego->ObtenerInstancia());

  // este fondo se mueve aunque la velocidad
  // del objeto de referencia sea 0
  // slo estara esttico si el objeto de referencia
  // se moviese a -1, -1
  g_pFondoJuego2->AsignarVelocRelativa(1,1);

  // crea el gestor de fondos
  // con el tamao de la ventana de visualizacin
  g_pGestorFondos = new cGestorFondos(g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura(), SIN_TOPE);

  // se agregan los dos fondos al gestor
  // se podra controlar el retorno de
  // la funcin (true = agreg el fondo)
  g_pGestorFondos->AgregarFondo(g_pFondoJuego);
  g_pGestorFondos->AgregarFondo(g_pFondoJuego2);

  // Pantalla inicial
  g_pPantallaInicial= new cBMP(hDC, IDB_PantallaInicial,
            g_pJuego->ObtenerInstancia());

  // Bitmaps del atleta
  g_pAtletaN = new cBMP(hDC, IDB_AtletaN, g_pJuego->ObtenerInstancia());
  g_pAtletaS = new cBMP(hDC, IDB_AtletaS, g_pJuego->ObtenerInstancia());
  g_pAtletaO = new cBMP(hDC, IDB_AtletaO, g_pJuego->ObtenerInstancia());
  g_pAtletaE = new cBMP(hDC, IDB_AtletaE, g_pJuego->ObtenerInstancia());
  g_pAtletaNAnimado = new cBMP(hDC, IDB_AtletaNAnimado, g_pJuego->ObtenerInstancia());
  g_pAtletaSAnimado = new cBMP(hDC, IDB_AtletaSAnimado, g_pJuego->ObtenerInstancia());
  g_pAtletaOAnimado = new cBMP(hDC, IDB_AtletaOAnimado, g_pJuego->ObtenerInstancia());
  g_pAtletaEAnimado = new cBMP(hDC, IDB_AtletaEAnimado, g_pJuego->ObtenerInstancia());

  // Fin del juego
  g_pFinJuego= new cBMP(hDC, IDB_FinJuego,
            g_pJuego->ObtenerInstancia());

  // Gestin del modo
  // se inicia con la pantalla
  // de presentacin (Splash)
  // hay 4 modos:
  // MODOSINICIO: pantalla de presentacin
  // MODODEMO: juego simulado
  // MODOJUEGO: juego real
  // MODOFIN: al finalizar cada juego y antes de
  // volver a aparecer la pantalla de principal
  g_bModo = MODOINICIO;
  // el modo splash es transitorio
  // despus pasar a modo demo
  g_iCiclosEspera = 0;

    // Inicializar los contadores del juego
  FJ_NuevoJuego();

  // Bfer auxiliar de repintado
  // Crea un contexto de dispositivo y un
  // mapa de bits adicional
  g_hBuferAuxDC = CreateCompatibleDC(hDC);
  g_hBuferAuxBitmap = CreateCompatibleBitmap(hDC,
      g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
  SelectObject(g_hBuferAuxDC , g_hBuferAuxBitmap);

 }
 void FJ_NuevoJuego()
{
  // Funcin de limpieza de las variables
  // para reiniciar un nuevo
  g_pJuego->LimpiarVector();    // Se limpian los sprites del vector

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

  g_bFinJuego = false;          // Indicador de fin de juego

  // Definicin de las reas de accin de  los
  // distintos tipos de sprites

  // el rea de movimiento = toda la pantalla
  RECT rcAreaJuego = {0, 0, 1000, 1600};

  // Atletas
  // Creamos el sprite del atleta
  // y lo almacenamos en el vector
  cSprite * pcsAtleta;
  pcsAtleta = new cSprite(g_pAtletaS, rcAreaJuego, AFL_DETENER);
  pcsAtleta->AsignarID(ATLETA);
  pcsAtleta->AsignarPosicion(200,200);
  g_pJuego->AgregarSprite(pcsAtleta);

  pcsAtleta = new cSprite(g_pAtletaS, rcAreaJuego, AFL_DETENER);
  pcsAtleta->AsignarID(ATLETA);
  pcsAtleta->AsignarPosicion(200,150);
  g_pJuego->AgregarSprite(pcsAtleta);

  // Reposiciona el viewport
  g_pGestorFondos->ReposicionarViewport();

  // Reinicia la reproduccin de la msica de fondo
  //////g_pJuego->MIDI(PLAYMIDI, TEXT("fondo.mid"));
}
// Funciones de mouse
void FJ_LButtonDown(LPARAM lParam)
{
   // Botn izquierdo reinicia el juego
   if (g_bFinJuego)
     FJ_NuevoJuego();

}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
    // Cuando se hace clic con el botn derecho
    // se selecciona un objeto
    // el objeto pasa a ser el foco del juego
    // y el fondo seguir su movimiento

    // el clic se hace en coordenadas de ventana
    // debemos sumarle las coordenadas del juego
    // para saber qu objeto hay en esa posicin de
    // la pantalla
    RECT rcRef = g_pGestorFondos->ObtenerViewport();

    cSprite * pObj = g_pJuego->HitTest(LOWORD(lParam)+rcRef.left, HIWORD(lParam)+ rcRef.top);

    // se presupone que no hay foco
    g_bFoco = false;
    if (pObj != NULL)
    {
        if (pObj->ObtenerID() == ATLETA)
        {
           // marca al objeto como enfocado
		   g_pJuego->AsignarObjetoEnfocado(pObj);
           g_bFoco = true;
        }
    }
 }
void FJ_RButtonUp(LPARAM lParam)
{
    if (g_bFoco)
    {
        // desplazar ventana de visualizacin
        // para centrarla en el objeto enfocado
        POINT ptCoord = {LOWORD(lParam), HIWORD(lParam)};

        // calculamos la distancia del clic
        // respecto del punto medio de la ventana
        ptCoord.x -= (g_pJuego->ObtenerAncho() / 2);
        ptCoord.y -= (g_pJuego->ObtenerAltura() / 2);

        // transportamos el viewport
        // para que el sprite quede en el medio
        g_pGestorFondos->TransportarViewport(ptCoord);
     }
}
void FJ_MouseMove(LPARAM lParam)
{
}
// Funciones de teclado
void FJ_CheckTeclado()
{
     if (GetAsyncKeyState(VK_F3) < 0)
    {
        // se reinicia el juego
        g_bModo = MODOJUEGO;
        FJ_NuevoJuego();
        return;
    }

    // Si no hay objeto enfocado la velocidad es cero
    cSprite * pObj = g_pJuego->ObtenerObjetoEnfocado();
    if (pObj == NULL)
           return;

    POINT ptVelocidad = pObj->ObtenerVelocidad();

     if (GetAsyncKeyState(VK_F4) < 0)
        ptVelocidad.x = ptVelocidad.y = 0;


    if (GetAsyncKeyState(VK_LEFT) < 0)
    {
        ptVelocidad.x -= 1;
        ptVelocidad.y = 0;
        // si la velocidad x es 0, cambia
        // la imagen
        if (ptVelocidad.x == 0)
        {
            pObj->CambiarImagen(g_pAtletaO);
            pObj->AsignarCantidadImagenes(1);
        }
    }
    if (GetAsyncKeyState(VK_RIGHT) < 0)
    {
        ptVelocidad.x += 1;
        ptVelocidad.y = 0;
        // si la velocidad x es 0, cambia
        // la imagen
        if (ptVelocidad.x == 0)
        {
            pObj->CambiarImagen(g_pAtletaE);
            pObj->AsignarCantidadImagenes(1);
        }
    }
    if (GetAsyncKeyState(VK_UP) < 0)
    {
        ptVelocidad.y -= 1;
        ptVelocidad.x = 0;
        if (ptVelocidad.y == 0)
        {
            pObj->CambiarImagen(g_pAtletaN);
            pObj->AsignarCantidadImagenes(1);
        }
    }
    if (GetAsyncKeyState(VK_DOWN) < 0)
    {
        ptVelocidad.y += 1;
        ptVelocidad.x = 0;
         if (ptVelocidad.y == 0)
        {
            pObj->CambiarImagen(g_pAtletaS);
            pObj->AsignarCantidadImagenes(1);
        }
    }
    // actualiza la velocidad del objeto
    pObj->AsignarVelocidad(ptVelocidad);

    // si la velocidad no es 0, el objeto
    // presenta animacin
    if (ptVelocidad.x != 0 || ptVelocidad.y != 0)
    {
        // la animacin depende de la direccin del objeto
        if (ptVelocidad.x < 0)
            pObj->CambiarImagen(g_pAtletaOAnimado);
        if (ptVelocidad.x > 0)
            pObj->CambiarImagen(g_pAtletaEAnimado);
        if (ptVelocidad.y < 0)
            pObj->CambiarImagen(g_pAtletaNAnimado);
        if (ptVelocidad.y > 0)
            pObj->CambiarImagen(g_pAtletaSAnimado);
        pObj->AsignarCantidadImagenes(4);

    }
}
void FJ_TeclaCaracter(WPARAM wParam)
{
}

// Comprobar joystick
void FJ_CheckJoystick(WORD wJoyEstado)
{
}
// Ciclo del juego
void FJ_CicloJuego()
{
    // El fondo del juego se pinta primero
    // se obtiene la velocidad y direccin del
    // fondo principal
	POINT ptVeloObjetoRef;
	ptVeloObjetoRef.x = ptVeloObjetoRef.y = 0;
	// Obtiene el objeto enfocado
	cSprite * pObj = g_pJuego->ObtenerObjetoEnfocado();
	// si el objeto no es nulo
	// obtiene su velocidad
	if (pObj != NULL)
		ptVeloObjetoRef = pObj->ObtenerVelocidad();

    // Actualiza las posiciones de los fondos
    // en base a la velocidad del objeto enfocado
    g_pGestorFondos->Actualizar(ptVeloObjetoRef);

    // Actualiza las posiciones de los sprites
    g_pJuego->ActualizarSprites();

    ++g_iContBucle;

    // Pintar en el contexto de dispositivo
    // auxiliar para eliminar
    // la sensacin de parpadeo
    FJ_PintarJuego(g_hBuferAuxDC);

    // Pintura real de la pantalla en una nica operacin
    HWND hVentana = g_pJuego->ObtenerVentana();
    HDC hDC = GetDC(hVentana);

    // se utilizan coordenadas 0, 0
    // porque se realiza copia completa
    // de un rea a otra
    BitBlt(hDC,
            0, 0, g_pJuego->ObtenerAncho(),
            g_pJuego->ObtenerAltura(),
            g_hBuferAuxDC, 0, 0,
        SRCCOPY);

    ReleaseDC(hVentana, hDC);

    // Se depuran los sprites marcados para eliminar
    g_pJuego->DepurarSprites();

}

void FJ_PintarJuego(HDC hDC)
{
    // se dibujan los fondos que
    // van atrs de los sprites
    // el resto (si hubiera) se dibuja despus
    // de los sprites
    g_pGestorFondos->Dibujar(hDC);

    // comprobamos en qu modo de interfaz estamos
    VerificarModo();

    // Si est en modo splash o demo
    // muestra la pantalla de presentacin
    // y los records actuales
    if (g_bModo & (MODOINICIO | MODODEMO))
    {
        g_pPantallaInicial->Dibujar(hDC,
            (g_pJuego->ObtenerAncho() -
             g_pPantallaInicial->ObtenerAncho()) / 2,
            (g_pJuego->ObtenerAltura() -
             g_pPantallaInicial->ObtenerAltura()) / 2,
            true);
    }
    // en modo demo o en modo juego o en modo wait
    // actualizamos los sprites de
    // la interfaz
    if (g_bModo != MODOINICIO)
    {

        // Ahora dibuja los sprites desde el vector
        // que pertenece al NucleoMotor
        // Slo se dibujan los sprites que estn dentro
        // del rea de visualizacin
        RECT rcViewport = g_pGestorFondos->ObtenerViewport();
        g_pJuego->DibujarSprites(hDC, rcViewport);

        char szTexto[100];

        // debugging
        POINT pt1;
        RECT rc1 = {0,0,0,0};
	    pt1.x = pt1.y = 0;
	    cSprite * pObj = g_pJuego->ObtenerObjetoEnfocado();
	    if (pObj != NULL)
	    {
	       rc1 = pObj->ObtenerPosicion();
		   pt1 = pObj->ObtenerVelocidad();
	    }

        POINT pt2 = g_pFondoJuego->ObtenerVelocRelativa();
        sprintf(szTexto, "Atleta = VA X Y= %d %d % VFondo = %d %d Ciclo %d",
             pt1.x, pt1.y, pt2.x, pt2.y, g_iContBucle);
        TextOut(hDC, 0, 0, szTexto, strlen(szTexto));

        RECT rc2 = g_pGestorFondos->ObtenerViewport();
        wsprintf(szTexto, "Pos PAT = %d %d , Coord.Juego = %d %d",
          rc1.left, rc1.top, rc2.left, rc2.top);
        TextOut(hDC, 0, 30, szTexto, strlen(szTexto));
        // fin debugging
   }
   // dibuja los fondos que van sobre los sprites
   // se pasa el ndice de la matriz de fondo (desde/hasta)
   g_pGestorFondos->Dibujar(hDC,2,2);

}
// Activacin y reactivacin del juego

void FJ_ReactivarJuego(HWND hWindow)
{
    // Capturar el joystick
    g_pJuego->CapturarJoystick();

    // reactiva la msica de fondo
    // con la msica que se estaba
    // reproduciendo en el momento
    // de la pausa
    ////g_pJuego->MIDI(PLAYMIDI,NULL,false);
}
void FJ_DetenerJuego(HWND hWindow)
{
    // Liberar el joystick
     g_pJuego->LiberarJoystick();

    // Suspende la msica de fondo
    ////g_pJuego->MIDI(PAUSARMIDI);
}

// Finalizacin del programa
void FJ_FinalizarJuego()
{
  // Elimina los elementos del bfer auxiliar
  DeleteObject(g_hBuferAuxBitmap);
  DeleteObject(g_hBuferAuxDC);

  // Elimina objetos bmp
  delete g_pAtletaN;
  delete g_pAtletaS;
  delete g_pAtletaO;
  delete g_pAtletaE;
  delete g_pAtletaNAnimado;
  delete g_pAtletaSAnimado;
  delete g_pAtletaOAnimado;
  delete g_pAtletaEAnimado;
  delete g_pFinJuego;
  delete g_pPantallaInicial;

  // Limpieza del vector de sprites
  g_pJuego->LimpiarVector();

  // elimina los objetos fondo
  delete g_pGestorFondos;
  delete g_pFondoJuego;
  delete g_pFondoJuego2;

  // Elimina el objeto
  delete g_pJuego;

  // Cierra el dispositivo
  ////g_pJuego->MIDI(CERRARMIDI);
}

// Control de las colisiones
// entre objetos cSprite
APC_ACCION FJ_NotificarColision(TC_COLISION tcColision,
        cSprite* pSprite, cSprite* pSpriteImpactado)
{
     switch (tcColision)
     {
        case TC_SPRITE:
          if ((pSprite->ObtenerID() == ATLETA &&
              pSpriteImpactado->ObtenerID() == ATLETA))
          {
              // se destruir el objeto impactado
              pSpriteImpactado->AsignarVisibilidad(false);
              PlaySound((LPCSTR) IDW_MISIL,
                            g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
              return APC_DESTRUIR;
           }
           break;

        case TC_LIMITES:

            break;
        // otras opciones
        // reservamos para uso futuro
    }
    return APC_NOACCION;
}

//-------------------------------------------------------
// Funciones propias de cada juego
//-------------------------------------------------------
void VerificarModo()
{
    switch(g_bModo)
    {
         case MODOINICIO:
            // para que en modo demo se reinicie
            // automticamente
            g_iCiclosEspera++;
            if (g_iCiclosEspera >= g_iEsperaModoDemo)
            {
                g_bModo = MODODEMO;
                FJ_NuevoJuego();
                return;
            }
            break;
          case MODODEMO:
            // de MODODEMO slo se sale con F3
            // que comienza el juego
                 if (g_bFinJuego)
                 {
                    FJ_NuevoJuego();
                    return;
                 }
                 break;
           case MODOJUEGO:
            // al finalizar cada juego
            // se entra en modo MODOWAIT, que
            // muestra la pantalla de fin de juego
            // durante un tiempo
                 if (g_bFinJuego)
                 {
                    g_bModo = MODOFIN;
                    g_iCiclosEspera = 0;
                    return;
                 }
                 break;
           case MODOFIN:
             // si entra en modo MODOFIN, se
             // muestra la pantalla de fin de juego
             // durante un tiempo y despus pasa
             // a MODOINICIO
                 g_iCiclosEspera++;
                 if (g_iCiclosEspera >= g_iEsperaModoDemo)
                {
                    g_bModo = MODOINICIO;
                    g_iCiclosEspera = 0;
                    return;
                }
                 break;
     }
 }



