//-----------------------------------------------------------------
// Objeto cGestorFondos
// Archivo de encabezado - cGestorFondos.h
//-----------------------------------------------------------------

#pragma once

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include <windows.h>
#include "cFondo.h"
#include "cSprite.h"
#include "cBMP.h"
#include <math.h>

const int LIMITE_FONDOS = 5;
//-----------------------------------------------------------------
// Indicadores de la accin al llegar al lmite del
// mapa de bits
//-----------------------------------------------------------------
const   WORD      SIN_TOPE          = 0x0000L,
                  TOPE_NORTE        = 0x0001L,
                  TOPE_SUR          = 0x0002L,
                  TOPE_VERTICAL     = 0x0003L,
                  TOPE_ESTE         = 0x0004L,
                  TOPE_OESTE        = 0x0008L,
                  TOPE_HORIZONTAL   = 0x000CL,
                  TOPE_TOTAL        = 0x000FL;

//-----------------------------------------------------------------
// Clase cGestorFondos
//-----------------------------------------------------------------
class cGestorFondos
{
protected:
  // Variables miembros
  int        m_iQFondos;        // Cantidad de fondos
  cFondo  *  m_pFondos[5];      // matriz de fondos
  RECT       m_rcViewportSize;  // Tamao de la ventana de visualizacin
  POINT      m_ptCoordViewport; // Distancia al punto 0, 0 del rea de juego
                                // medida hasta el vrtice superior izquierdo
                                // de la ventana de visualizacin
  WORD       m_lfLimite;        // define gestin de lmites del fondo
  int        m_iFondoMaster;    // Define cul es el fondo principal

public:
  // Constructor
  cGestorFondos(int iAncho = 200, int iAltura = 200, WORD lfLimite = SIN_TOPE);

  // Destructor
  virtual ~cGestorFondos();

  // Mtodos

  // Actualiza los fondos en base a la velocidad
  // de cada uno
  virtual void  Actualizar(POINT ptVeloObj);

  // Dibujo en capas de los fondos
  virtual bool  Dibujar(HDC hDC, int iFondoIni = 1, int iFondoFin = 1);

  // Transporte de las coordenadas del puerto de visualizacin
  void          TransportarViewport(POINT ptCoord);

  // Para el reinicio del juego
  void          ReposicionarViewport();

  // Informa el viewport vigente
  RECT          ObtenerViewport();

  // Gestin de fondos
  bool          AgregarFondo(cFondo* pFondo, bool bMaster = false);
  void          EliminarFondos();

  // Definicin de tipo de lmites
  // para el fondo
  void          AsignarLimite(WORD lfLimite)
                    { m_lfLimite = lfLimite;}
};



